#ifndef _NOKIALCD_H_
#define _NOKIALCD_H_

/* Lcd screen size */
#define LCD_X_RES 84
#define LCD_Y_RES 48
#define LCD_CACHE_SIZE ((LCD_X_RES * LCD_Y_RES) / 8)

/* Pinout for LCD */
#define LCD_CLK_PIN (1 << PC6)
#define LCD_DATA_PIN (1 << PC5)
#define LCD_DC_PIN (1 << PC4)
#define LCD_CE_PIN (1 << PC3)
#define LCD_RST_PIN (1 << PC2)
#define LCD_PORT PORTC
#define LCD_DDR DDRC

/* Special Chars */
#define ARROW_RIGHT ICON(0)
#define ARROW_LEFT ICON(1)
#define ARROW_UP ICON(2)
#define ARROW_DOWN ICON(3)
#define STOP ICON(4)
#define PLAY ICON(5)

/* Function for my special characters */
#define ICON(x) 'z' + 1 + x

void initialize_LCD(void);
void lcd_contrast(unsigned char contrast);
void lcd_clear(void);
void lcd_clear_area(unsigned char line, unsigned char startX, unsigned char endX);
void lcd_clear_line(unsigned char line);
void set_cursor_position(unsigned char x, unsigned char y);
void set_cursor_position_exact(unsigned char x, unsigned char y);
void lcd_chr(char chr);
void lcd_str(char *str);

/* Custom functions */
void draw_current_pos_on_LCD(int x, int y);
void remove_cursor(int x, int y);
void move_cursor_left(int x, int y);
void move_cursor_right(int x, int y);
void move_cursor_up(int x, int y);
void move_cursor_down(int x, int y);
void save_ship_coords(int x, int y);
void draw_miss_cell_to_lcd(int x, int y);
void draw_hit_cell_to_lcd(int x, int y);
void print_hello();
void print_wait();
void my_turn_prompt();
void win_prompt();
void lose_prompt();
void draw_map_to_lcd(void);

#endif
